apt: pkgAcqMetaClearSig Class Reference

apt 3.3.2 commandline package manager

Public Member Functions | Public Attributes | List of all members
pkgAcqMetaClearSig Class Referencefinal
Acquire system {{{

An item responsible for downloading clearsigned metaindexes {{{. More...

`#include <apt-pkg/acquire-item.h>`

Inheritance diagram for pkgAcqMetaClearSig:

## Public Member Functions
void | Failed (std::string const &Message, pkgAcquire::MethodConfig const *Cnf) override
| Invoked by the acquire worker when the object couldn't be fetched.
std::string | Custom600Headers () const override
| Custom headers to be sent to the fetch process.
bool | VerifyDone (std::string const &Message, pkgAcquire::MethodConfig const *Cnf) override
| Invoked by the acquire worker to check if the successfully fetched object is also the objected we wanted to have.
void | Done (std::string const &Message, HashStringList const &Hashes, pkgAcquire::MethodConfig const *Cnf) override
| Invoked by the acquire worker when the object was fetched successfully.
void | DoCancelled ()
void | Finished () override
| Invoked by the worker when the download is completely done.
void | QueueIndexes (bool const verify)
| Starts downloading the individual index files.
| pkgAcqMetaClearSig (pkgAcquire *const Owner, IndexTarget const &ClearsignedTarget, IndexTarget const &DetachedDataTarget, IndexTarget const &DetachedSigTarget, metaIndex *const MetaIndexParser)
| Create a new pkgAcqMetaClearSig.
Public Member Functions inherited from pkgAcqMetaIndex
std::string | DescURI () const override
| A "descriptive" URI-like string.
void | Failed (std::string const &Message, pkgAcquire::MethodConfig const *Cnf) override
| Invoked by the acquire worker when the object couldn't be fetched.
void | Done (std::string const &Message, HashStringList const &Hashes, pkgAcquire::MethodConfig const *Cnf) override
| Invoked by the acquire worker when the object was fetched successfully.
| pkgAcqMetaIndex (pkgAcquire *const Owner, pkgAcqMetaClearSig *const TransactionManager, IndexTarget const &DataTarget, IndexTarget const &DetachedSigTarget) APT_NONNULL(2
| Create a new pkgAcqMetaIndex.
Public Member Functions inherited from pkgAcqMetaBase
bool | QueueURI (pkgAcquire::ItemDesc &Item) override
| Insert this item into its owner's queue.
HashStringList | GetExpectedHashes () const override
bool | HashesRequired () const override
void | Add (pkgAcqTransactionItem *const I)
void | AbortTransaction ()
bool | TransactionHasError () const
void | CommitTransaction ()
void | TransactionStageCopy (pkgAcqTransactionItem *const I, const std::string &From, const std::string &To)
| Stage (queue) a copy action when the transaction is committed.
void | TransactionStageRemoval (pkgAcqTransactionItem *const I, const std::string &FinalFile)
| Stage (queue) a removal action when the transaction is committed.
std::string | GetFinalFilename () const override
| Get the full pathname of the final file for the current URI.
| pkgAcqMetaBase (pkgAcquire *const Owner, pkgAcqMetaClearSig *const TransactionManager, IndexTarget const &DataTarget) APT_NONNULL(2
Public Member Functions inherited from pkgAcqTransactionItem
std::string | DescURI () const override
| A "descriptive" URI-like string.
HashStringList | GetExpectedHashes () const override
virtual std::string | GetMetaKey () const
bool | HashesRequired () const override
virtual bool | AcquireByHash () const
| pkgAcqTransactionItem (pkgAcquire *const Owner, pkgAcqMetaClearSig *const TransactionManager, IndexTarget const &Target) APT_NONNULL(2
Public Member Functions inherited from pkgAcquire::Item
APT_HIDDEN void | FailMessage (std::string const &Message)
virtual void | Start (std::string const &Message, unsigned long long const Size)
| Invoked when the worker starts to fetch this object.
APT_HIDDEN std::unordered_map< std::string, std::string > & | ModifyCustomFields ()
APT_HIDDEN bool | PopAlternativeURI (std::string &NewURI)
APT_HIDDEN bool | IsGoodAlternativeURI (std::string const &AltUri) const
APT_HIDDEN void | PushAlternativeURI (std::string &&NewURI, std::unordered_map< std::string, std::string > &&fields, bool const at_the_back)
APT_HIDDEN void | RemoveAlternativeSite (std::string const &AltUri)
virtual std::string | ShortDesc () const
| Short item description.
APT_HIDDEN void | Cancelled ()
| Invoked by the worker when the download is cancelled before completion.
std::string | HashSum () const
pkgAcquire * | GetOwner () const
pkgAcquire::ItemDesc & | GetItemDesc ()
virtual bool | IsTrusted () const
void | SetActiveSubprocess (std::string const &subprocess)
| Set the name of the current active subprocess.
| Item (pkgAcquire *const Owner)
| Initialize an item.
virtual | ~Item ()
| Remove this item from its owner's queue by invoking pkgAcquire::Remove.
bool APT_HIDDEN | IsRedirectionLoop (std::string const &NewURI)
int APT_HIDDEN | Priority ()
| The priority of the item, used for queuing.
void APT_HIDDEN | FetchAfter (time_point FetchAfter)
| internal clock definitions to avoid typing all that all over the place
time_point APT_HIDDEN | FetchAfter ()
Public Member Functions inherited from WeakPointable
void | AddWeakPointer (WeakPointable **weakptr)
void | RemoveWeakPointer (WeakPointable **weakptr)
| ~WeakPointable ()

## Public Attributes
metaIndex * | MetaIndexParser
| A package-system-specific parser for the meta-index file.
metaIndex * | LastMetaIndexParser
Public Attributes inherited from pkgAcqMetaBase
bool | IMSHit
TransactionStates | State
std::string | BaseURI
Public Attributes inherited from pkgAcqTransactionItem
IndexTarget const | Target
std::string | PartialFile
| storge name until a transaction is finished
pkgAcqMetaClearSig *const | TransactionManager
| TransactionManager.
Public Attributes inherited from pkgAcquire::Item
enum pkgAcquire::Item::ItemState | Status
std::string | ErrorText
| Contains a textual description of the error encountered if ItemState is StatError or StatAuthError.
unsigned long long | FileSize
| The size of the object to fetch.
unsigned long long | PartialSize
| How much of the object was already fetched.
std::string | ActiveSubprocess
| contains the name of the subprocess that is operating on this object (for instance, "gzip", "rred" or "gpgv"). This is obsoleting #Mode from above as it can manage the lifetime of included string properly.
unsigned long | ID
| A client-supplied unique identifier.
bool | Complete
| If true, the entire object has been successfully fetched.
bool | Local
| If true, the URI of this object is "local".
std::string | UsedMirror
unsigned int | QueueCounter
| The number of fetch queues into which this item has been inserted.
unsigned int | ExpectedAdditionalItems
| The number of additional fetch items that are expected once this item is done.
std::string | DestFile
| The name of the file into which the retrieved object will be written.
unsigned int | Retries
| Number of retries.

## Additional Inherited Members
Public Types inherited from pkgAcqTransactionItem
enum | TransactionStates { TransactionStarted , TransactionCommit , TransactionAbort }
Public Types inherited from pkgAcquire::Item
enum | ItemState { StatIdle , StatFetching , StatDone , StatError , StatAuthError , StatTransientNetworkError }
| The current status of this item. More...
Protected Types inherited from pkgAcquire::Item
enum | RenameOnErrorState { HashSumMismatch , SizeMismatch , InvalidFormat , SignatureError , NotClearsigned , MaximumSizeExceeded , PDiffError }
Protected Member Functions inherited from pkgAcqMetaIndex
void | Init (std::string const &URIDesc, std::string const &ShortDesc)
| delayed constructor
Protected Member Functions inherited from pkgAcqMetaBase
bool | CheckDownloadDone (pkgAcqTransactionItem *const I, const std::string &Message, HashStringList const &Hashes) const
| Called when a file is finished being retrieved.
void | QueueForSignatureVerify (pkgAcqTransactionItem *const I, std::string const &File, std::string const &Signature)
| Queue the downloaded Signature for verification.
bool | CheckAuthDone (std::string const &Message, pkgAcquire::MethodConfig const *const Cnf)
| Called when authentication succeeded.
bool | CheckStopAuthentication (pkgAcquire::Item *const I, const std::string &Message)
bool | VerifyVendor (std::string const &Message)
| Check that the release file is a release file for the correct distribution.
bool | TransactionState (TransactionStates state) override
Protected Member Functions inherited from pkgAcqTransactionItem
HashStringList | GetExpectedHashesFor (std::string const &MetaKey) const
bool | QueueURI (pkgAcquire::ItemDesc &Item) override
| Insert this item into its owner's queue.
Protected Member Functions inherited from pkgAcquire::Item
bool | RenameOnError (RenameOnErrorState const state)
| Rename failed file and set error.
void | Dequeue ()
| Remove this item from its owner's queue.
bool | Rename (std::string const &From, std::string const &To)
| Rename a file without modifying its timestamp.
Protected Attributes inherited from pkgAcqMetaIndex
IndexTarget const | DetachedSigTarget
Protected Attributes inherited from pkgAcqMetaBase
std::vector< pkgAcqTransactionItem * > | Transaction
bool | AuthPass
| If true, the index's signature is currently being verified.
Protected Attributes inherited from pkgAcquire::Item
pkgAcquire *const | Owner
| The acquire object with which this item is associated.
pkgAcquire::ItemDesc | Desc
| The item that is currently being downloaded.

## Detailed Description

An item responsible for downloading clearsigned metaindexes {{{.

## Member Function Documentation

## ◆ Custom600Headers()

string Custom600Headers | ( |  | ) | const
| nodiscardoverridevirtual

Custom headers to be sent to the fetch process.

Returns
  a string containing RFC822-style headers that are to be inserted into the 600 URI Acquire message sent to the fetch subprocess. The headers are inserted after a newline-less line, so they should (if nonempty) have a leading newline and no trailing newline.

Reimplemented from pkgAcqMetaBase.

References pkgAcqMetaBase::Custom600Headers(), and pkgAcqTransactionItem::TransactionManager.

## ◆ Done()

void Done | ( | std::string const & | Message,
|  | HashStringList const & | Hashes,
|  | pkgAcquire::MethodConfig const * | Cnf )
| overridevirtual

Invoked by the acquire worker when the object was fetched successfully.

Note that the object might not have been written to DestFile; check for the presence of an Alt-Filename entry in Message to find the file to which it was really written.

Done is often used to switch from one stage of the processing to the next (e.g. fetching, unpacking, copying). It is one branch of the continuation of the fetch process.

Parameters

  Message | Data from the acquire method. Use LookupTag() to parse it.
  Hashes | The HashSums of the object that was fetched.
  Cnf | The method via which the object was fetched.

See also
  pkgAcqMethod

Reimplemented from pkgAcquire::Item.

References pkgAcqMetaBase::AuthPass, pkgAcqMetaBase::CheckAuthDone(), pkgAcqMetaBase::CheckDownloadDone(), pkgAcquire::Item::DestFile, pkgAcqMetaBase::GetFinalFilename(), pkgAcquire::Item::Owner, pkgAcqMetaBase::QueueForSignatureVerify(), pkgAcquire::Item::StatAuthError, and pkgAcqTransactionItem::TransactionManager.

## ◆ Failed()

void Failed | ( | std::string const & | Message,
|  | pkgAcquire::MethodConfig const * | Cnf )
| overridevirtual

Invoked by the acquire worker when the object couldn't be fetched.

This is a branch of the continuation of the fetch process.

Parameters

  Message | An RFC822-formatted message from the acquire method describing what went wrong. Use LookupTag() to parse it.
  Cnf | The method via which the worker tried to fetch this object.

See also
  pkgAcqMethod

Reimplemented from pkgAcquire::Item.

References pkgAcqMetaBase::AuthPass, pkgAcqMetaBase::CheckStopAuthentication(), pkgAcquire::Item::DestFile, pkgAcquire::Item::ErrorText, pkgAcqMetaBase::GetFinalFilename(), pkgAcquire::Item::Owner, pkgAcqMetaIndex::pkgAcqMetaIndex(), pkgAcquire::Item::Rename(), pkgAcquire::Item::StatAuthError, pkgAcquire::Item::StatDone, pkgAcquire::Item::StatTransientNetworkError, pkgAcqTransactionItem::TransactionManager, and pkgAcqMetaBase::VerifyVendor().

## ◆ Finished()

void Finished | ( |  | ) |
| overridevirtual

Invoked by the worker when the download is completely done.

Reimplemented from pkgAcquire::Item.

References pkgAcquire::Item::DestFile, and pkgAcqTransactionItem::TransactionManager.

## ◆ QueueIndexes()

void QueueIndexes | ( | bool const | verify | ) |

Starts downloading the individual index files.

Parameters

  verify | If true, only indices whose expected hashsum can be determined from the meta-index will be downloaded, and the hashsums of indices will be checked (reporting StatAuthError if there is a mismatch). If verify is false, no hashsum checking will be performed.

Todo
  We should support Standalone-Architecture-Variants field here

References pkgAcquire::Item::ExpectedAdditionalItems, pkgAcquire::Item::Owner, and pkgAcqTransactionItem::TransactionManager.

## ◆ VerifyDone()

bool VerifyDone | ( | std::string const & | Message,
|  | pkgAcquire::MethodConfig const * | Cnf )
| overridevirtual

Invoked by the acquire worker to check if the successfully fetched object is also the objected we wanted to have.

Note that the object might not have been written to DestFile; check for the presence of an Alt-Filename entry in Message to find the file to which it was really written.

This is called before Done is called and can prevent it by returning false which will result in Failed being called instead.

You should prefer to use this method over calling Failed() from Done() as this has e.g. the wrong progress reporting.

Parameters

  Message | Data from the acquire method. Use LookupTag() to parse it.
  Cnf | The method via which the object was fetched.

See also
  pkgAcqMethod

Reimplemented from pkgAcquire::Item.

References pkgAcquire::Item::DestFile, and pkgAcquire::Item::RenameOnError().

The documentation for this class was generated from the following files:

- apt-pkg/acquire-item.h
- apt-pkg/acquire-item.cc